#if !defined( _mcmc_constrained_basis_fn_regression_h )
#define _mcmc_constrained_basis_fn_regression_h

#include "mcmc_basis_fn_regression.h"
class MCMC_Constrained_Basis_Fn_Regression : public MCMC_Basis_Fn_Regression
{
  public:
   ///
   MCMC_Constrained_Basis_Fn_Regression( int argc, char **argv );
   ///
   MCMC_Constrained_Basis_Fn_Regression( gsl_matrix* X1, gsl_matrix* Y1 );// uses matrix,matrix constructor of base class
   ///
   MCMC_Constrained_Basis_Fn_Regression( gsl_matrix* X1, gsl_matrix* Y1, gsl_matrix* D1 );// uses matrix,matrix,matrix constructor of base class
   ///
   ~MCMC_Constrained_Basis_Fn_Regression();
   ///
   void initialise();

   virtual void post_move_updates();// Carries out any updates required after the move, accepted or not.

   virtual void update_ergodic_averages();//overwritten fn updating model averages
   
  private:
   
   map< Basis_Fn*, double > process_values;//The process defining the constrained function.
      
   int process_order;//Determines whether process is peicewise constant, linear, etc.

   long positive_negative;// 1 if the process is first positive, then negative, -1 if negative then positive, 0 if either will do.

   bool inflection_point;//point approximately at which the process changes sign.
};

#endif

