#include <iostream>
#include "glm_mvn.h"

using std::cout;
using std::endl;
using std::ios;
using namespace std;

int main(int argc, char* argv[])
{
   GLM_MVN G( argc, argv );
   for( int i = 1; i < argc; i++ )
      if( strstr( argv[i], "help" ) )
         exit(1);
   double lp = G.calculate_log_posterior();
   int numobsns = G.get_number_of_subjects();
   cout << numobsns << " observations." << endl;
   cout << "Log Posterior = " << lp;
   cout << " ,   Average Log Posterior = " << lp / numobsns << endl;   
   gsl_matrix* mean = G.get_m_star();
   G.set_basis_coefficients( mean );
   G.make_grid_predictions( 0 );
   double l2value = 0, intmodvalue = 0;
   G.monte_carlo_estimate_l2_distance_from_zero_and_absolute_integral( l2value, intmodvalue );
   cout << "               L2 distance from zero funtion = " << l2value << endl;
   cout << "Integral of abolute value of spline_function = " << intmodvalue << endl;
   cout << "E[Noise Variance|Data] = " << G.get_e_sigma_sq() << endl;
   cout << "R-squared = " << G.get_r_squared() << endl;
   G.calculate_correlation_matrix();
//   G.calculate_residual_variogram();
   return 0;
}
