// spline_basis_fn.h

#if !defined( _spline_basis_fn_h )
#define _spline_basis_fn_h

#include "basis_fn.h"

using namespace std;
///
class Spline_Basis_Fn : public Basis_Fn

{
  public:
   ///
   Spline_Basis_Fn();
   ///
   Spline_Basis_Fn( double* v, int terms, int* cmp, int* pw, int* sgn, int* actv_dim = NULL ); // creates a terms-way interaction basis fn with knots at v, on data components cmp with powers pw and signs sn.
   ///
   Spline_Basis_Fn( double d, int cmp, int pw, int sgn, int* actv_dim = NULL ); // creates a 1-way interaction basis fn with knot at d, on data component cmp with power pw and sign sn.
   ///
   virtual ~Spline_Basis_Fn();
   ///
   virtual double evaluate( double* x, int* actv_dim = NULL, int order_integral = 0, int integral_component = 0 );//evaluate the order_integral'th integral of the basis fn in the intergral_component direction for the gsl::vector x.

 private:

 protected:

};   

#endif

